# Load necessary library
library(gpuR)

ORDER <- 8192

# On CPU
A <- matrix(rnorm(ORDER^2), nrow=ORDER)
B <- matrix(rnorm(ORDER^2), nrow=ORDER)
ctime <- system.time(C <- A %*% B)
print(paste("On CPU:",ctime["elapsed"],"seconds"))

# On GPU
vclA <- vclMatrix(rnorm(ORDER^2), nrow=ORDER, ncol=ORDER)
vclB <- vclMatrix(rnorm(ORDER^2), nrow=ORDER, ncol=ORDER)
gtime <- system.time(vclC <- vclA %*% vclB)
print(paste("On GPU:",gtime["elapsed"],"seconds"))

print(paste("The speedup is",ctime["elapsed"]/gtime["elapsed"]))


