# Load necessary library
library(gpuR)

ORDER <- 8192

# On CPU
ctime <- system.time({
A <- matrix(rnorm(ORDER^2), nrow=ORDER)
B <- matrix(rnorm(ORDER^2), nrow=ORDER)
C <- A %*% B
})
print(paste("On CPU:",ctime["elapsed"],"seconds"))

# On GPU
gtime <- system.time({
vclA <- vclMatrix(rnorm(ORDER^2), nrow=ORDER, ncol=ORDER)
vclB <- vclMatrix(rnorm(ORDER^2), nrow=ORDER, ncol=ORDER)
vclC <- vclA %*% vclB
})
print(paste("On GPU:",gtime["elapsed"],"seconds"))

print(paste("The speedup is",ctime["elapsed"]/gtime["elapsed"]))


